# remirepo/fedora spec file for php-cs-fixer
#
# Copyright (c) 2016-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    454ddbe65da6a9297446f442bad244e8a99a9a38
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
#global gh_date      20150717
%global gh_owner     FriendsOfPHP
%global gh_project   PHP-CS-Fixer
%global php_home     %{_datadir}/php
%global with_tests   0%{!?_without_tests:1}

# Bundled this fork which is not designed for use outside of php-cs-fixer
%global gh_diff_owner   PHP-CS-Fixer
%global gh_diff_version 1.2.0
%global gh_diff_commit  f0ef6133d674137e902fdf8a6f2e8e97e14a087b
%global gh_diff_short   %(c=%{gh_diff_commit}; echo ${c:0:7})

Name:           php-cs-fixer
Version:        2.9.0
Release:        2%{?gh_date:.%{gh_date}git%{gh_short}}%{?dist}
Summary:        A tool to automatically fix PHP code style

Group:          Development/Tools
License:        MIT
URL:            https://github.com/%{gh_owner}/%{gh_project}
# git snapshot to get upstream test suite
Source0:        %{name}-%{version}-%{gh_short}.tgz
Source1:        %{name}-diff-%{gh_diff_version}-%{gh_diff_short}.tgz
Source2:        makesrc.sh

# Use our autoloader
Patch0:         %{name}-autoload.patch

BuildArch:      noarch
%if %{with_tests}
# For tests
%if 0%{?fedora} >= 26
BuildRequires:  php(language) >= 7.0
%global phpunit %{_bindir}/phpunit6
%global gecko_min 3.0
%global gecko_max 4
%else
BuildRequires:  php(language) >= 5.6
%global phpunit %{_bindir}/phpunit
%global gecko_min 2.0
%global gecko_max 3
%endif
BuildRequires:  php-tokenizer
BuildRequires:  php-composer(composer/semver)          <  2
BuildRequires:  php-composer(composer/semver)          >= 1.4
BuildRequires:  php-composer(doctrine/annotations)     <  2
BuildRequires:  php-composer(doctrine/annotations)     >= 1.2
BuildRequires:  php-composer(gecko-packages/gecko-php-unit) <  %{gecko_max}
BuildRequires:  php-composer(gecko-packages/gecko-php-unit) >= %{gecko_min}
BuildRequires:  php-symfony3-console
BuildRequires:  php-symfony3-event-dispatcher
BuildRequires:  php-symfony3-filesystem
BuildRequires:  php-symfony3-finder
BuildRequires:  php-symfony3-options-resolver
BuildRequires:  php-composer(symfony/polyfill-php70)   <  2
BuildRequires:  php-composer(symfony/polyfill-php70)   >= 1.0
BuildRequires:  php-composer(symfony/polyfill-php72)   <  2
BuildRequires:  php-composer(symfony/polyfill-php72)   >= 1.4
BuildRequires:  php-symfony3-process
BuildRequires:  php-symfony3-stopwatch
BuildRequires:  php-composer(sebastian/diff)           <  2
BuildRequires:  php-composer(sebastian/diff)           >= 1.4
BuildRequires:  php-mbstring
BuildRequires:  php-xml
BuildRequires:  php-reflection
BuildRequires:  php-dom
BuildRequires:  php-json
BuildRequires:  php-pcre
BuildRequires:  php-phar
BuildRequires:  php-spl
BuildRequires:  php-xml
# Missing dependency for Console
BuildRequires:  php-symfony3-debug
BuildRequires:  php-symfony3-debug
# From composer.json,     "require-dev": {
# NOTICE: listener disabled during test suite
#        "johnkary/phpunit-speedtrap": "^1.1 || ^2.0@dev",
#        "justinrainbow/json-schema": "^5.0",
#        "mikey179/vfsStream": "^1.6",
#        "php-coveralls/php-coveralls": "^2.0",
#        "php-cs-fixer/accessible-object": "^1.0",
#        "phpunit/phpunit": "^5.7.23 || ^6.4.3",
#        "symfony/phpunit-bridge": "^3.2.2 || ^4.0"
BuildRequires:  php-composer(justinrainbow/json-schema) <  6
BuildRequires:  php-composer(justinrainbow/json-schema) >= 5.0
BuildRequires:  php-composer(mikey179/vfsStream) <  2
BuildRequires:  php-composer(mikey179/vfsStream) >= 1.6
BuildRequires:  php-composer(php-cs-fixer/accessible-object) <  2
BuildRequires:  php-composer(php-cs-fixer/accessible-object) >= 1.0
BuildRequires:  %{phpunit}
BuildRequires:  php-symfony3-phpunit-bridge >= 3.2.2
# Autoloader
BuildRequires:  php-fedora-autoloader-devel
%endif

# From composer.json,     "require": {
#        "php": "^5.6 || >=7.0 <7.3",
#        "ext-json": "*",
#        "ext-tokenizer": "*",
#        "composer/semver": "^1.4",
#        "doctrine/annotations": "^1.2",
#        "gecko-packages/gecko-php-unit": "^2.0 || ^3.0",
# Bundled
#        "php-cs-fixer/diff": "^1.2",
#        "symfony/console": "^3.2 || ^4.0",
#        "symfony/event-dispatcher": "^3.0 || ^4.0",
#        "symfony/filesystem": "^3.0 || ^4.0",
#        "symfony/finder": "^3.0 || ^4.0",
#        "symfony/options-resolver": "^3.0 || ^4.0",
#        "symfony/polyfill-php70": "^1.0",
#        "symfony/polyfill-php72": "^1.4",
#        "symfony/polyfill-xml": "^1.3",
#        "symfony/process": "^3.0 || ^4.0",
#        "symfony/stopwatch": "^3.0 || ^4.0"
Requires:       php(language) >= 5.6
Requires:       php-json
Requires:       php-tokenizer
Requires:       php-composer(composer/semver)          <  2
Requires:       php-composer(composer/semver)          >= 1.4
Requires:       php-composer(doctrine/annotations)     <  2
Requires:       php-composer(doctrine/annotations)     >= 1.2
Requires:       php-composer(gecko-packages/gecko-php-unit) <  %{gecko_max}
Requires:       php-composer(gecko-packages/gecko-php-unit) >= %{gecko_min}
Requires:       php-composer(sebastian/diff)           <  2
Requires:       php-composer(sebastian/diff)           >= 1.4
Requires:       php-symfony3-console
Requires:       php-symfony3-event-dispatcher
Requires:       php-symfony3-filesystem
Requires:       php-symfony3-finder
Requires:       php-symfony3-options-resolver
Requires:       php-composer(symfony/polyfill-php70)   <  2
Requires:       php-composer(symfony/polyfill-php70)   >= 1.0
Requires:       php-composer(symfony/polyfill-php72)   <  2
Requires:       php-composer(symfony/polyfill-php72)   >= 1.4
Requires:       php-symfony3-process
Requires:       php-symfony3-stopwatch
# Missing dependency for Console
Requires:       php-symfony3-debug
# From composer.json, "suggest": {
#        "ext-mbstring": "For handling non-UTF8 characters in cache signature.",
#        "symfony/polyfill-mbstring": "When enabling `ext-mbstring` is not possible."
Requires:       php-mbstring
# From phpcompatinfo report for version 2.4.0
Requires:       php-cli
Requires:       php-reflection
Requires:       php-dom
Requires:       php-pcre
Requires:       php-phar
Requires:       php-spl
Requires:       php-xml
# Autoloader
Requires:       php-composer(fedora/autoloader)

Provides:       bundled(php-cs-fixer/diff) = %{gh_diff_version}
Provides:       php-composer(friendsofphp/php-cs-fixer) = %{version}


%description
The PHP Coding Standards Fixer tool fixes most issues in your code when you
want to follow the PHP coding standards as defined in the PSR-1 and PSR-2
documents and many more.

If you are already using a linter to identify coding standards problems in
your code, you know that fixing them by hand is tedious, especially on large
projects. This tool does not only detect them, but also fixes them for you.


%prep
%setup -q -n %{gh_project}-%{gh_commit} -a1
%patch0 -p1 -b .rpm
mv diff-%{gh_diff_commit}/src src/diff

find src -name \*rpm -delete -print

# from composer.json, "autoload" / "classmap"
TESTS="
  tests/Test/Assert/AssertTokensTrait.php
  tests/Test/AbstractFixerTestCase.php
  tests/Test/AbstractIntegrationTestCase.php
  tests/Test/IntegrationCase.php
  tests/Test/IntegrationCaseFactory.php
"
for i in $TESTS; do
  mkdir -p src/$(dirname $i)
  cp -p $i src/$i
done

# fix dev-tools path
sed -e 's:../../../dev-tools/::' -i src/Console/Command/HelpCommand.php
cp -pr dev-tools/ci-integration.sh  src/Console/Command/

phpab --template fedora --output src/autoload.php src/tests src/diff

cat << 'EOF' | tee -a src/autoload.php

\Fedora\Autoloader\Autoload::addPsr4('PhpCsFixer\\', __DIR__);
if (class_exists('PHPUnit\\Runner\\Version') && version_compare(PHPUnit\Runner\Version::id(), '6', '>')) {
    $gecko = [
        '%{php_home}/GeckoPackages/PHPUnit3/autoload.php',
        '%{php_home}/GeckoPackages/PHPUnit/autoload.php',
    ];
} else {
    $gecko = [
        '%{php_home}/GeckoPackages/PHPUnit/autoload.php',
        '%{php_home}/GeckoPackages/PHPUnit3/autoload.php',
    ];
}
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}//Composer/Semver/autoload.php',
    $gecko,
    '%{php_home}/Doctrine/Common/Annotations/autoload.php',
    '%{php_home}/Symfony3/Component/Console/autoload.php',
    '%{php_home}/Symfony3/Component/EventDispatcher/autoload.php',
    '%{php_home}/Symfony3/Component/Filesystem/autoload.php',
    '%{php_home}/Symfony3/Component/Finder/autoload.php',
    '%{php_home}/Symfony3/Component/OptionsResolver/autoload.php',
    '%{php_home}/Symfony3/Component/Process/autoload.php',
    '%{php_home}/Symfony3/Component/Stopwatch//autoload.php',
    '%{php_home}/Symfony/Polyfill/autoload.php',
]);
EOF


%build
# Empty build section, most likely nothing required.


%install
: Library
mkdir -p   %{buildroot}%{php_home}
cp -pr src %{buildroot}%{php_home}/PhpCsFixer

: Command
install -Dpm755 %{name} %{buildroot}%{_bindir}/%{name}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
// Force version for local, when both versions are available
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Symfony3/Bridge/PhpUnit/autoload.php',
    '%{php_home}/org/bovigo/vfs/autoload.php',
    '%{php_home}/JsonSchema5/autoload.php',
    '%{php_home}/PhpCsFixer/AccessibleObject/autoload.php',
    '%{buildroot}%{php_home}/PhpCsFixer/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('PhpCsFixer\\Tests\\', dirname(__DIR__) . '/tests');
EOF

# Fix integration test
sed -e "/README.rst/s:__DIR__.*':'$PWD/README.rst':" \
    -i tests/Console/Command/ReadmeCommandTest.php
rm tests/CiIntegrationTest.php

# Disable listener
sed -e 's/listeners/nolistener/' phpunit.xml.dist >phpunit.xml

# Redirect to buildroot
sed -e 's:%{php_home}:%{buildroot}%{php_home}:' -i %{name}

ret=0
for cmdarg in "php %{phpunit}" "php56 %{_bindir}/phpunit" php70 php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 -d memory_limit=1G ${2:-%{_bindir}/phpunit6} || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc composer.json
%doc *.md *.rst
%{php_home}/PhpCsFixer
%{_bindir}/%{name}


%changelog
* Thu Dec 28 2017 Remi Collet <remi@remirepo.net> - 2.9.0-2
- mikey179/vfsStream only required at builtime

* Sat Dec  9 2017 Remi Collet <remi@remirepo.net> - 2.9.0-1
- Update to 2.9.0

* Mon Nov 27 2017 Remi Collet <remi@remirepo.net> - 2.8.3-1
- Update to 2.8.3
- open https://github.com/FriendsOfPHP/PHP-CS-Fixer/issues/3279
  bad tag for 2.8.3

* Mon Nov 20 2017 Remi Collet <remi@remirepo.net> - 2.8.2-1
- Update to 2.8.2

* Fri Nov 10 2017 Remi Collet <remi@remirepo.net> - 2.8.1-1
- Update to 2.8.1

* Tue Nov  7 2017 Remi Collet <remi@remirepo.net> - 2.8.0-3
- fix FTBFS from Koschei using symfony package names

* Fri Nov  3 2017 Remi Collet <remi@remirepo.net> - 2.8.0-2
- use phpunit6 and php-gecko-packages-gecko-php-unit3 on F26+

* Fri Nov  3 2017 Remi Collet <remi@remirepo.net> - 2.8.0-1
- Update to 2.8.0

* Mon Oct  2 2017 Remi Collet <remi@remirepo.net> - 2.7.1-1
- Update to 2.7.1

* Mon Oct  2 2017 Remi Collet <remi@remirepo.net> - 2.7.0-1
- Update to 2.7.0
- drop dependency on sebastian/diff, bundle fork instead

* Mon Oct  2 2017 Remi Collet <remi@remirepo.net> - 2.6.1-1
- Update to 2.6.1

* Tue Sep 12 2017 Remi Collet <remi@remirepo.net> - 2.6.0-1
- Update to 2.6.0
- add dependency on composer/semver

* Wed Aug 23 2017 Remi Collet <remi@remirepo.net> - 2.5.0-1
- Update to 2.5.0
- add dependency on php-cs-fixer/accessible-object
- raise dependency on symfony 3.2

* Thu Aug  3 2017 Remi Collet <remi@remirepo.net> - 2.4.0-1
- Update to 2.4.0
- add dependency on symfony/polyfill-php72

* Thu May 25 2017 Remi Collet <remi@remirepo.net> - 2.3.2-1
- Update to 2.3.2
- add dependency on gecko-packages/gecko-php-unit

* Tue May  9 2017 Remi Collet <remi@remirepo.net> - 2.3.1-1
- Update to 2.3.1
- raise dependency on PHP 5.6
- raise dependency on Symfony 3

* Wed Apr 26 2017 Remi Collet <remi@remirepo.net> - 2.2.3-1
- Update to 2.2.3

* Mon Apr 24 2017 Remi Collet <remi@remirepo.net> - 2.2.2-1
- Update to 2.2.2
- raise dependency on sebastian/diff >= 1.4

* Mon Apr 10 2017 Remi Collet <remi@remirepo.net> - 2.2.1-1
- Update to 2.2.1

* Sat Apr  1 2017 Remi Collet <remi@remirepo.net> - 2.2.0-1
- Update to 2.2.0
- add dependency on doctrine/annotations
- add dependency on symfony/options-resolver
- raise dependency on symfony 2.6
- fix autoloader to allow Symfony 3

* Fri Mar 31 2017 Remi Collet <remi@remirepo.net> - 2.1.3-1
- Update to 2.1.3
- add dependency on php-mbstring

* Wed Mar 15 2017 Remi Collet <remi@remirepo.net> - 2.1.2-1
- Update to 2.1.2

* Fri Mar  3 2017 Remi Collet <remi@remirepo.net> - 2.1.1-1
- Update to 2.1.1

* Sat Feb 11 2017 Remi Collet <remi@fedoraproject.org> - 2.1.0-1
- update to 2.1.0
- add dependency on symfony/polyfill-php55 (for EPEL-7)

* Thu Feb  9 2017 Remi Collet <remi@fedoraproject.org> - 2.0.1-1
- update to 2.0.1

* Thu Dec  1 2016 Remi Collet <remi@fedoraproject.org> - 2.0.0-1
- update to 2.0.0

* Tue Nov 29 2016 Remi Collet <remi@fedoraproject.org> - 1.13.0-1
- update to 1.13.0

* Tue Nov 15 2016 Remi Collet <remi@fedoraproject.org> - 1.12.4-1
- update to 1.12.4

* Sun Oct 30 2016 Remi Collet <remi@fedoraproject.org> - 1.12.3-1
- update to 1.12.3
- switch from symfony/class-loader to fedora/autoloader

* Tue Sep 27 2016 Remi Collet <remi@fedoraproject.org> - 1.12.2-1
- update to 1.12.2

* Fri Sep  9 2016 Remi Collet <remi@fedoraproject.org> - 1.12.1-1
- initial package, version 1.12.1

